/* Sample code using the Chunks and Tasks programming model.
 * See <http://www.chunks-and-tasks.org>.
 */
#include "Fibonacci.h"

struct Add: public cht::Task {
  cht::ID execute(CInt const & n1, CInt const & n2);
  CHT_TASK_INPUT((CInt, CInt));
  CHT_TASK_OUTPUT((CInt));
  CHT_TASK_TYPE_DECLARATION;
};

CHT_TASK_TYPE_IMPLEMENTATION((Add));
cht::ID Add::execute(CInt const & n1, CInt const & n2) {
  CInt result_chunk = n1+n2;
  cht::ChunkID cid_result = 
    registerChunk(new CInt(result_chunk));
  return cid_result;
}

CHT_TASK_TYPE_IMPLEMENTATION((Fibonacci));
cht::ID Fibonacci::execute(CInt const & n) {
  if(n < 2) 
    return getInputChunkID(n);
  cht::ChunkID c1 = registerChunk( new CInt(n-1) );
  cht::ID t1 = registerTask<Fibonacci>( c1 );
  cht::ChunkID c2 = registerChunk( new CInt(n-2) );
  cht::ID t2 = registerTask<Fibonacci>( c2 );
  return registerTask<Add>(t1, t2);
} // end execute
