/* Sample code using the Chunks and Tasks programming model.
 * See <http://www.chunks-and-tasks.org>.
 */
#include <iostream>
#include "chunks_and_tasks.h"
#include "Fibonacci.h"
int main() {
  int n = 13;
  cht::start();
  cht::ChunkID cid_n = cht::registerChunk(new CInt(n));
  cht::ChunkID cid_result = 
    cht::executeMotherTask<Fibonacci>(cid_n);
  // Get result.
  cht::shared_ptr<CInt const> result;
  cht::getChunk(cid_result, result);
  // Delete chunks.
  cht::deleteChunk(cid_n);
  cht::deleteChunk(cid_result);
  // Stop cht services
  cht::stop();
  std::cout << "The thirteenth Fibonacci number is " 
	    << *result << std::endl;
  return 0;
}

